local L = LibStub("AceLocale-3.0"):GetLocale("ISpy", true)

ISpy_Options = {
	name = L["ISpy"],
	type = "group",
	handler = ISpy,
	get = "GetValue",
	set = "SetValue",
	args = {
		Output = {
			order = 0,
			name = L["Output Options"],
			type = "group",
			inline = true,
			args = {
				private = {
					order = 13,
					name = L["Private"],
					type = "toggle",
				},
				say = {
					order = 1,
					name = L["Say"],
					type = "toggle",
				},
				yell = {
					order = 2,
					name = L["Yell"],
					type = "toggle",
				},
				party = {
					order = 3,
					name = L["Party"],
					type = "toggle",
				},
				guild = {
					order = 4,
					name = L["Guild"],
					type = "toggle",
				},
				officer = {
					order = 5,
					name = L["Officer"],
					type = "toggle",
				},
				raid = {
					order = 6,
					name = L["Raid"],
					type = "toggle",
				},
				raidwarning = {
					order = 7,
					name = L["Raid warning"],
					type = "toggle",
				},
				battleground = {
					order = 8,
					name = L["Battleground"],
					type = "toggle",
				},
				whisper = {
					order = 9,
					name = L["Whisper"],
					type = "toggle",
				},
				playername = {
					order = 10,
					name = L["Player name"],
					type = "input",
					disabled = function(info) return not ISpy.db.profile.whisper end,
				},
				channel = {
					order = 11,
					name = L["Channel"],
					type = "toggle",
				},
				channelname = {
					order = 12,
					name = L["Channel name"],
					type = "input",
					disabled = function(info) return not ISpy.db.profile.channel end,
				},
			},
		},
		monitoring = {
			order = 4,
		   name = L["Monitoring"],
			type = "group",
			inline = true,
			args = {
				interrupt = {
					order = 5,
					name = L["Interrupt"],
					type = "toggle",
				},
				steal = {
					order = 6,
					name = L["Spellsteal"],
					type = "toggle",
				},
				debuff_friendly = {
					order = 7,
					name = L["Friend debuffs"],
					type = "toggle",
				},
				debuff_hostile = {
					order = 8,
					name = L["Enemy debuffs"],
					type = "toggle",
				},
				auraremoved = {
					order = 9,
					name = L["Removed auras"],
					type = "toggle",
				},
				aurabroken = {
					order = 10,
					name = L["Broken auras"],
					type = "toggle",
				},
				aurabrokenspell = {
					order = 11,
					name = L["Broken aura details"],
					type = "toggle",
				},
				death = {
					order = 12,
					name = L["Deaths"],
					type = "toggle",
				},
			},
		},
		otheroptions = {
			order = 9,
			name = L["Other options"],
			type = "group",
			inline = true,
			args = {
				pvp = {
					order = 1,
					name = L["Enable in PvP zones"],
					type = "toggle",
				},
				onlyingroup = {
					order = 2,
					name = L["Only when in a group"],
					type = "toggle",
				},
				onlygroup = {
					order = 2,
					name = L["Only players in your group"],
					type = "toggle",
				},
				enable = {
					order = 10,
					name = L["Enable ISpy"],
					type = "execute",
					hidden = true,
					func = function(info) ISpy:Enable() end,
				},
				disable = {
					order = 11,
					name = L["Disable ISpy"],
					type = "execute",
					hidden = function(info) return not ISpy.options.args.otheroptions.args.enable.hidden end,
					func = function(info) ISpy:Disable() end,
				},
			},
		},
	},
}

function ISpy:GetValue(info)
	local this = info[#info]
	return self.db.profile[this]
end

function ISpy:SetValue(info, value)
	local this = info[#info]
	self.db.profile[this] = value
end